#!/bin/sh

DetectionModel()
{
	Eth1=`cat /proc/net/dev | grep "eth1"`
	if [ "$Eth1" != "" ];then
	printf "UA-2241\n"
	else
	printf "UA-5231\n"
	fi
}
FirstSetHostName()
{
	while [ true ]
	do
		HWaddr=`ifconfig | grep "eth0"`
		if [ "$HWaddr" != "" ]; then
			break;
		fi
		sleep 1
	done
	echo "UA-Series-"`ifconfig | grep "eth0" | grep "HWaddr" | awk '{print $5}' | sed 's/://g'` > /etc/hostname
}
RemoveTmp()
{
	rm -rf /Init/tmp/*;
}

DetectionNetWork()
{	
	
	IPAddress0=`ifconfig eth0 | grep "HWaddr" | awk '{print $5}' | sed 's/://g'`
	IPAddress0=`echo $IPAddress0 | tr '[:upper:]' '[:lower:]'`
		
	IPAddress1=`ifconfig eth1 | grep "HWaddr" | awk '{print $5}' | sed 's/://g'`
	IPAddress1=`echo $IPAddress1 | tr '[:upper:]' '[:lower:]'`
	
	
	while [ true ]
	do	
		
		eth0_ip=$(ifconfig eth0 | grep 'inet ' | awk '{print $2}' | sed 's/addr://')
		eth1_ip=$(ifconfig eth1 | grep 'inet ' | awk '{print $2}' | sed 's/addr://')

		ppp0_ip=""
		if [ -d "/sys/class/net/ppp0" ]; 
		then
			ppp0_ip=$(ifconfig ppp0 | grep 'inet ' | awk '{print $2}' | sed 's/addr://')
		
		fi		
		
		eth0_carrier=$(cat /sys/class/net/eth0/carrier)
		eth1_carrier=$(cat /sys/class/net/eth1/carrier)
		                                
		if [ -f "/tmp/defaultGateway" ]
		then		
			iface=$(cat /tmp/defaultGateway | awk NR==1)
			ip=$(cat /tmp/defaultGateway | awk NR==2)
			route add default gw  ${ip} netmask 0.0.0.0 ${iface}
			route add default gw  ${ip} netmask 0.0.0.0 ${iface}
			rm -f /tmp/defaultGateway

		fi

		routeRule_1=$(route  | grep default | awk 'NR==1')
		gatewayIface=$( echo "$routeRule_1" | awk '{print $8}' | tr -d '\n')
		gatewayIP=$( echo "$routeRule_1" | awk '{print $2}')
			
		if [ -z  "$eth0_ip" ] && [ $eth0_carrier -eq 1 ]; 
		then	
							
			if [  "$gatewayIP" = "*" ] && [ "$gatewayIface" = "eth1" ];
			then
				connmanctl \disconnect "ethernet_"$IPAddress1"_cable"
				connmanctl \connect "ethernet_"$IPAddress0"_cable"
                		connmanctl \connect "ethernet_"$IPAddress1"_cable"
			else
			    connmanctl \connect "ethernet_"$IPAddress0"_cable"
			fi
		fi
		
		if [ -z "$eth1_ip" ] && [ $eth1_carrier -eq 1 ]; 
		then	
           								  
			if [ "$gatewayIP" = "*" ] && [ "$gatewayIface" = "eth0" ];
			then
				connmanctl \disconnect "ethernet_"$IPAddress0"_cable"
				connmanctl \connect "ethernet_"$IPAddress1"_cable"
				connmanctl \connect "ethernet_"$IPAddress0"_cable"
			else
				connmanctl \connect "ethernet_"$IPAddress1"_cable"
			fi
		fi
		
		if [ "$ppp0_ip" ] && [ "$gatewayIface" != "ppp0" ];
		then
		  	 ip route del default dev ppp0
			 route add default dev  ppp0
		fi
		
	sleep 2
	done
}


