import psutil
import time

def analysis_port_status(port):
    # define data structure for each connection, each ip is unique unit
    ipaddress = {
        'ipaddress': None,
        'counts': 0,
        'stat': {
            'established': 0,
            'time_wait': 0,
            'syn_recv': 0,
            'close_wait':0,
            'others': 0
        }
    }

    # define data structure for statistics
    statistics = {
        'portIsUsed': False,
        'portUsedCounts': 0,
        'portPeerList': [
            {
                'ipaddress': None,
                'counts': 0,
                'stat': {
                    'established': 0,
                    'time_wait': 0,
                    'syn_recv': 0,
                    'close_wait':0,
                    'others': 0
                 
                },
            },
        ]
    }

    tmp_portPeerList = list()
    portPeerSet = set()
    netstat = psutil.net_connections()

    # get all ip address only for statistics data

    for i, sconn in enumerate(netstat):
        if port in sconn.laddr:
            statistics['portIsUsed'] = True
            if len(sconn.raddr) != 0:
                statistics['portUsedCounts'] += 1
                ipaddress['ipaddress'] = sconn.raddr[0]
                tmp_portPeerList.append(str(ipaddress))  # dict() list() set() is unhashable type, collections.Counter

    for ip in tmp_portPeerList:
        portPeerSet.add(str(ip))  # remove duplicated ip address using set()

    for member in portPeerSet:
        statistics['portPeerList'].append(eval(member))

    # add statistics data for each ip address
    for sconn in netstat:
        if port in sconn.laddr:
            if len(sconn.raddr) != 0:
                for i, item in enumerate(statistics['portPeerList']):
                    if item['ipaddress'] == sconn.raddr[0]:
                        statistics['portPeerList'][i]['counts'] += 1
                        if sconn.status == 'ESTABLISHED':
                            statistics['portPeerList'][i]['stat']['established'] += 1
                        elif sconn.status == 'TIME_WAIT':
                            statistics['portPeerList'][i]['stat']['time_wait'] += 1
                        elif sconn.status == 'SYN_RECV':
                            statistics['portPeerList'][i]['stat']['syn_recv'] += 1
                        elif sconn.status == 'CLOSE_WAIT':
                            statistics['portPeerList'][i]['stat']['close_wait'] += 1
                        else:
                            statistics['portPeerList'][i]['stat']['others'] += 1

    # print statistics result using prettytable
    ip_status_list= list()
    if statistics['portIsUsed']:
        for i, ip in enumerate(statistics['portPeerList']):
            if ip['ipaddress'] is not None:
                ip_status={}
                ip_status['ip']=ip['ipaddress']
                ip_status['established']=ip['stat']['established']
                ip_status['syn_recv']=ip['stat']['syn_recv']
                ip_status['close_wait']= ip['stat']['close_wait']
                ip_status_list.append(ip_status)
             
    return ip_status_list