#! /bin/bash

. ./function.sh

ClearEeprom;
ShowStartInstall;

Return=$(SetStaticIP);
if [ $Return -eq -1 ]; then
    ShowNetworkConnectionError;
    Beep 4 0.001 0.5;
    exit 0;
fi

Return=$(CheckTarFileName);
if [ $Return -eq -1 ]; then
    ShowCheckTarFileNameError;
    Beep 4 0.001 0.5;
    exit 0;
fi

Beep 1 1 0.001;
ClearApp;
RemoveApp;
RemoveFactory;
CreateEnvironment;
CopyInstallFileToEnvironment;

Return=$(ComparisonTarFile);
if [ $Return -eq -1 ]; then
    ShowComparisonTarFileError;
    Beep 4 0.001 0.5;
    exit 0;
fi

DecompressedFile;
CopyEnvironment;
SetEnvironment;

Return=$(Runtimepackage_verification);
if [ $Return -eq -1 ]; then
    ShowRuntimePackageError;
    Beep 4 0.001 0.5;
    exit 0;
fi

ChmodFile;
DeleteResidualFile;
Sync;
SetEeprom "Factory";
/Init/Device_Driver/Multi_ComPort_driver.sh;
ShowInstallSuccess;
Beep 1 1 0.5;
Beep 1 1 0.001;
